package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.context.VariableContext;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import javax.annotation.Nullable;

public interface OperationProcessor extends ClassResponder
{
	/**
	 * @param mt - The method being tested.  May differ from the method the operation belongs
	 *           to in the case this is a before or after test method.  Null if processing
	 *           a before or after class method.
	 * @param op
	 * @return handled if the operation was handled, reject to skip, and defer to allow a downstream
	 *         listener to evaluate.
	 * @throws TestAssertionFailure
	 *
	 * @throws TestExecutionError
	 * @throws TestWarning
	 */
	action_code process(@Nullable ETLTestMethod mt, ETLTestOperation op, ETLTestValueObject parameters, VariableContext vcontext, ExecutionContext econtext)
			throws TestAssertionFailure, TestExecutionError, TestWarning;
}